#ifndef ASTRASECURITYMONITORHELPER_H
#define ASTRASECURITYMONITORHELPER_H

#include <QList>
#include "gmc-common_global.h"
#include "switchdefines.h"

class SwitchWidget;
class SwitchWidgetBuilder;

class GMC_COMMON_SHARED_EXPORT AstraSecurityMonitorHelper
{
public:
    static AstraSecurityMonitorHelper *instance();
    ~AstraSecurityMonitorHelper();
    void reloadSwitches();
    const QList <SwitchWidget *> getSwitches() const;
    const QList <SwitchWidget *> getSwitches(const SwitchGroup &group) const;
    const QStringList getScripts() const;
    const QStringList getScripts(const SwitchGroup &group) const;

private:
    AstraSecurityMonitorHelper();
    const QMultiMap<SwitchGroup, SwitchWidget *> switches();
    const QByteArray call(const QStringList &arguments, int timeout) const;

    static AstraSecurityMonitorHelper *m_instance;
    SwitchWidgetBuilder *m_builder = nullptr;
    QMultiMap<SwitchGroup, SwitchWidget *> m_switchMap;
};

#endif // ASTRASECURITYMONITORHELPER_H
