#ifndef JSONHANDLER_H
#define JSONHANDLER_H

class QJsonObject;
class QJsonDocument;
class QJsonArray;
class QJsonValue;
class QString;
class QByteArray;

class JsonHandler
{
public:
    JsonHandler() = delete;
    static QJsonArray extractJsonArray(const QByteArray &json);
    static QJsonObject extractJsonObject(const QJsonValue &value);
    static double extractDouble(const QJsonObject &object, const QString &key);
    static QString extractString(const QJsonObject &object, const QString &key);
    static bool extractBool(const QJsonObject &object, const QString &key);

private:
    static QJsonObject extractJsonObject(const QJsonDocument &document);
    static QJsonArray extractJsonArray(const QJsonDocument &document);
    static QJsonDocument extractJsonDocument(const QByteArray &json);
    static QJsonValue extractJsonValue(const QJsonObject &object, const QString &key);
    static double extractDouble(const QJsonValue &value);
    static QString extractString(const QJsonValue &value);
    static bool extractBool(const QJsonValue &value);

};

#endif // JSONHANDLER_H
