#ifndef SWITCHWIDGETBUILDER_H
#define SWITCHWIDGETBUILDER_H

#include "gmc-common_global.h"
#include "switchdefines.h"
#include <QString>

class SwitchWidget;
class QObject;

class GMC_COMMON_SHARED_EXPORT SwitchWidgetBuilder
{
public:
    SwitchWidgetBuilder() noexcept;
    ~SwitchWidgetBuilder();

    void setId(const QString &id);
    void setName(const QString &name);
    void setLongName(const QString &longname);
    void setExtraText(const QString &extratext);
    void setTooltip(const QString &tooltip);
    void setSlave(const QString &slave);
    void setGroup(const SwitchGroup &group);
    void setScript(const QString &script);
    void setGray(const bool gray);
    void setRebootCase(const bool onEnable, const bool onDisable);

    SwitchWidget *buildAndClear();

private:

    void clearFields();
    QString m_id = QString();
    QString m_name = QString();
    QString m_longname = QString();
    QString m_extraText = QString();
    QString m_tooltip = QString();
    QString m_slave = QString();
    SwitchGroup m_group = SwitchGroup::System;
    QString m_script = QString();
    bool m_gray = false;
    bool m_rebootOnEnable = false;
    bool m_rebootOnDisable = false;
};

#endif // SWITCHWIDGETBUILDER_H
